searchNodes=[{"doc":"Csv schema is a library helping you to build Ecto schema-like files having as source a csv file. The idea behind this library is give the possibility to create, at compile-time, getters function for a CSV inside codebase. APIs related to this macro are similar to Ecto.Schema; Eg. defmodule Person do use Csv.Schema, headers: true, separator: ?, alias Csv.Schema.Parser schema &quot;path/to/person.csv&quot; do field :id, &quot;id&quot;, key: true field :first_name, &quot;first_name&quot;, filter_by: true field :last_name, &quot;last_name&quot;, sort: :asc field :identifier, [&quot;first_name&quot;, &quot;last_name&quot;], key: true, join: &quot; &quot; field :email, &quot;email&quot;, unique: true field :gender, &quot;gender&quot;, filter_by: true, sort: :desc field :ip_address, &quot;ip_address&quot; field :date_of_birth, &quot;date_of_birth&quot;, parser: &amp;Parser.date!(&amp;1, &quot;{0M}/{0D}/{0YYYY}&quot;) end end At the end of compilation now your module is a Struct and has 3 kind of getters: by_{key_field_name} returns single records object or nil filter_by_{field_name} returns list of records matching provided property get_all returns all records Back to the example in the module will be created: __MODULE__.by_id/1 expecting integer as arg __MODULE__.filter_by_name/1 expecting string as arg __MODULE__.by_fiscal_code/1 expecting string as arg __MODULE__.get_all/0 Some example definitions could be found here","ref":"Csv.Schema.html","title":"Csv.Schema","type":"module"},{"doc":"separator it&#39;s possible to set a separator argument to macro to let the macro split csv for you using provided separator. header if your csv file does not have headers, it&#39;s possible to set headers to false and configure fields by index (1..N)","ref":"Csv.Schema.html#__using__/1","title":"Csv.Schema.__using__/1","type":"macro"},{"doc":"Configure a new field (csv column). Parameters are name - new struct field name column - header name or column index (if headers: false) in csv file opts - list of configuration values :key - boolean; at most one key must be set. It is something similar to a primary key :unique - boolean; creates a function by_{name} for you :filter_by - boolean; do i create a filter_by_{name} function for this field for you? :parser - function; parser function used to get_changeset data from string to custom type :sort - :asc or :desc; It sorts according to Erlang&#39;s term ordering with nil exception :join - string; if present it joins the given fields into a binary using the separator","ref":"Csv.Schema.html#field/3","title":"Csv.Schema.field/3","type":"macro"},{"doc":"Schema macro helps you to build a block of fields. First parameter should be the relative path to csv file in your project. Second parameter should be a field list included in do-end block","ref":"Csv.Schema.html#schema/2","title":"Csv.Schema.schema/2","type":"macro"},{"doc":"","ref":"Csv.Schema.html#t:name/0","title":"Csv.Schema.name/0","type":"type"},{"doc":"","ref":"Csv.Schema.html#t:order/0","title":"Csv.Schema.order/0","type":"type"},{"doc":"","ref":"Csv.Schema.html#t:row/0","title":"Csv.Schema.row/0","type":"type"},{"doc":"Utility module containing some functions for parsing and to read csv file","ref":"Csv.Schema.Parser.html","title":"Csv.Schema.Parser","type":"module"},{"doc":"Having a string or an atom as input cast value to atom. If something else is given an exception is raised If given argument is empty string or nil return value will be nil Examples iex&gt; Csv.Schema.Parser.atom!(&quot;&quot;) nil iex&gt; Csv.Schema.Parser.atom!(nil) nil iex&gt; Csv.Schema.Parser.atom!(&quot;id&quot;) :id iex&gt; Csv.Schema.Parser.atom!(:id) :id iex&gt; Csv.Schema.Parser.atom!(1) ** (RuntimeError) Cannot cast &#39;1&#39; to atom","ref":"Csv.Schema.Parser.html#atom!/1","title":"Csv.Schema.Parser.atom!/1","type":"function"},{"doc":"Having a string as input cast value to boolean. If something else is given an exception is raised If given argument is empty string or nil return value will be nil Examples iex&gt; Csv.Schema.Parser.boolean!(&quot;&quot;) nil iex&gt; Csv.Schema.Parser.boolean!(nil) nil iex&gt; Csv.Schema.Parser.boolean!(&quot;true&quot;) true iex&gt; Csv.Schema.Parser.boolean!(&quot;false&quot;) false iex&gt; Csv.Schema.Parser.boolean!(&quot;1a&quot;) ** (RuntimeError) Cannot cast &#39;1a&#39; to boolean","ref":"Csv.Schema.Parser.html#boolean!/1","title":"Csv.Schema.Parser.boolean!/1","type":"function"},{"doc":"Given a csv file path try to parse as csv with headers. Use list of maps as data representation","ref":"Csv.Schema.Parser.html#csv!/3","title":"Csv.Schema.Parser.csv!/3","type":"function"},{"doc":"Having a string as input representing string date to parse and a string representing the date format try to cast value to date. If something else is given or format is invalid or date is not parsable with given format an exception is raised If given argument is empty string or nil return value will be nil Examples iex&gt; Csv.Schema.Parser.date!(&quot;&quot;, &quot;whatever&quot;) nil iex&gt; Csv.Schema.Parser.date!(nil, &quot;whatever&quot;) nil iex&gt; Csv.Schema.Parser.date!(&quot;18/01/2019&quot;, &quot;{0D}/{0M}/{0YYYY}&quot;) ~N[2019-01-18 00:00:00] iex&gt; Csv.Schema.Parser.date!(&quot;18/01/2019&quot;, &quot;{0M}/{0D}/{0YYYY}&quot;) ** (RuntimeError) Cannot cast &#39;18/01/2019&#39; to date with format &#39;{0M}/{0D}/{0YYYY}&#39; iex&gt; Csv.Schema.Parser.date!(&quot;18/01/2019&quot;, &quot;MDY&quot;) ** (RuntimeError) Invalid date format &#39;MDY&#39;","ref":"Csv.Schema.Parser.html#date!/2","title":"Csv.Schema.Parser.date!/2","type":"function"},{"doc":"Having a string as input cast value to float. If something else is given an exception is raised If given argument is empty string or nil return value will be nil Examples iex&gt; Csv.Schema.Parser.float!(&quot;&quot;) nil iex&gt; Csv.Schema.Parser.float!(nil) nil iex&gt; Csv.Schema.Parser.float!(&quot;1.2&quot;) 1.2 iex&gt; Csv.Schema.Parser.float!(&quot;1a&quot;) ** (RuntimeError) Cannot cast &#39;1a&#39; to float","ref":"Csv.Schema.Parser.html#float!/1","title":"Csv.Schema.Parser.float!/1","type":"function"},{"doc":"Having a string as input cast value to integer. If something else is given an exception is raised If given argument is empty string or nil return value will be nil Examples iex&gt; Csv.Schema.Parser.integer!(&quot;&quot;) nil iex&gt; Csv.Schema.Parser.integer!(nil) nil iex&gt; Csv.Schema.Parser.integer!(&quot;1&quot;) 1 iex&gt; Csv.Schema.Parser.integer!(&quot;1a&quot;) ** (RuntimeError) Cannot cast &#39;1a&#39; to integer","ref":"Csv.Schema.Parser.html#integer!/1","title":"Csv.Schema.Parser.integer!/1","type":"function"},{"doc":"Having a string or an atom as input cast value to string. If something else is given an exception is raised. If given argument is empty string or nil return value will be nil Examples iex&gt; Csv.Schema.Parser.string!(&quot;&quot;) nil iex&gt; Csv.Schema.Parser.string!(nil) nil iex&gt; Csv.Schema.Parser.string!(&quot;id&quot;) &quot;id&quot; iex&gt; Csv.Schema.Parser.string!(:id) &quot;id&quot; iex&gt; Csv.Schema.Parser.string!(1) ** (RuntimeError) Cannot cast &#39;1&#39; to string","ref":"Csv.Schema.Parser.html#string!/1","title":"Csv.Schema.Parser.string!/1","type":"function"}]